#ifndef HELPFAQFORM_TEMPLATE_H
#define HELPFAQFORM_TEMPLATE_H

#include <qvariant.h>


#include <Qt3Support/Q3MimeSourceFactory>
#include <Qt3Support/Q3TextBrowser>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QPushButton>

QT_BEGIN_NAMESPACE

class Ui_HelpFaqForm_template
{
public:
    QGridLayout *gridLayout;
    QPushButton *closePushButton;
    Q3TextBrowser *textBrowser3_2;

    void setupUi(QDialog *HelpFaqForm_template)
    {
    if (HelpFaqForm_template->objectName().isEmpty())
        HelpFaqForm_template->setObjectName(QString::fromUtf8("HelpFaqForm_template"));
    HelpFaqForm_template->resize(540, 553);
    gridLayout = new QGridLayout(HelpFaqForm_template);
    gridLayout->setSpacing(6);
    gridLayout->setMargin(11);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    closePushButton = new QPushButton(HelpFaqForm_template);
    closePushButton->setObjectName(QString::fromUtf8("closePushButton"));

    gridLayout->addWidget(closePushButton, 1, 0, 1, 1);

    textBrowser3_2 = new Q3TextBrowser(HelpFaqForm_template);
    textBrowser3_2->setObjectName(QString::fromUtf8("textBrowser3_2"));

    gridLayout->addWidget(textBrowser3_2, 0, 0, 1, 1);


    retranslateUi(HelpFaqForm_template);
    QObject::connect(closePushButton, SIGNAL(clicked()), HelpFaqForm_template, SLOT(close()));

    QMetaObject::connectSlotsByName(HelpFaqForm_template);
    } // setupUi

    void retranslateUi(QDialog *HelpFaqForm_template)
    {
    HelpFaqForm_template->setWindowTitle(QApplication::translate("HelpFaqForm_template", "FET - Frequently asked questions", 0, QApplication::UnicodeUTF8));
    closePushButton->setText(QApplication::translate("HelpFaqForm_template", "Close", 0, QApplication::UnicodeUTF8));
    textBrowser3_2->setText(QApplication::translate("HelpFaqForm_template", "FET FAQ:\n"
"\n"
"this documentation by Liviu Lalescu, reviewed and modified - 5 December 2008 (new additions are written with date, most are at the end)\n"
"\n"
"--------\n"
"\n"
"\n"
"Q: What is the organization of FET input data?\n"
"\n"
"A: - Students - organized into sets (years (or forms, or classes), containing groups, containing subgroups).\n"
"\n"
"- Teachers.\n"
"\n"
"- Subjects (the names of the possible courses, eg. Maths, Physics, etc.).\n"
"\n"
"- Activity tags (you can use them or not, option is yours: the type of activity: lab, course, seminary, or any other information attached to an activity).\n"
"\n"
"- Rooms (classrooms).\n"
"\n"
"- Activities: a coupling of one or more teachers, a subject and one or more students set. This is usually named a course, a lecture, a laboratory and so on. An activity can have optionally an activity tag, to help you with some constraints.\n"
"\n"
"- Constraints. They can be: time constraints (referring to the allocated day and hour) or space constraints (referri"
        "ng to rooms allocation). They have a weight percentage, from 0.0% to 100.0%. 100% means that the constraint will always be respected and if this constraint is impossible, FET will not be able to generate a timetable.\n"
"\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: Why some activities appear indented while others not?\n"
"\n"
"A: The activities are indented for easier visualization. The non-indented ones are the representatives of a larger split activity (their id is the group id of the larger split activity), while indented ones are the other components of this larger split activity.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"\n"
"Q: Is it possible to use non-integer weights for constraints?\n"
"\n"
"A: Yes. Using values like 99.75% might be good sometimes.\n"
"\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"\n"
"Q: Help on ConstraintStudentsEarlyMa"
        "xBeginningsAtSecondHour.\n"
"\n"
"You can specify the maximum number of beginnings at second available hour (arrivals at third hour not possible).\n"
"\n"
"If you input only partial data, please use with caution. If you add a constraint with max 0 beginnings at second hour: you might for instance input only 4+4 hourly activities of math with the same teacher for 2 students sets (each group of 4 activities must be ballanced - in different days). Then it is clear that you cannot place all 8 activities in a 5 days week without breaking the students early constraint, so you will get no possible timetable.\n"
"\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"\n"
"Q: How does FET work?\n"
"\n"
"A: A heuristic algorithm, based on swapping activities recursively to make space for new activities. Email the author or mailing list for details.\n"
"\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: How about optional subje"
        "cts or students sets which are divided according to options?\n"
"\n"
"A: One possible approach: in FET you can have each activity with more teachers and students sets. If you have for instance students set S which must attend subject Language1, English (with teacher TE) or French (teacher TF), you might choose not divide S and add an activity with Language1, S and TE and TF. The drawback: each activity can take place in a single room, you cannot tell FET that this activity should be in 2 or more rooms at the same time, and from here derive other problems: if some room is not available, if capacity of room is too low for the number of students in S FET cannot find timetable, and maybe others.\n"
"\n"
"Another possible approach: you may need to define students into sections (see question below).\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: How to define the students into sections?\n"
"\n"
"A: FET can automatically divide years by at most 3 categories of opt"
        "ions. If you need to divide a year into 4 categories, you can use a small trick (see below).\n"
"\n"
"Add years and the option \"Divide ...\" in the years dialog is the easiest way. You can also add manually years, groups and subgroups.\n"
"\n"
"If each year (for instance 9) is divided by at most 3 categories, you can add year 9 and divide it in 3 categories. If a year is divided by 4 categories (for instance, year 9 is divided by: section (a, b, c, d), language (en, fr), religion and boys/girls, you might consider years: 9a, 9b, 9c, 9d, each divided into 3 categories, and divide each year in the dialog. For more than 4 categories, very unlikely case, you will need to manually adjust groups/subgroups.\n"
"\n"
"Important: you must consider that each year contains groups which contain independent subgroups. Subgroups should have all the activities of the year and group plus additional optional activities. Please check menu statistics/students for subgroups, each subgroup should have a reasonable number of workin"
        "g hours per week, close to the average of hours per week for all subgroups.\n"
"\n"
"An impossible timetable might be caused by incorrect years division. Please check statistics/students for all subgroups, each subgroup should have the necessary hours, not less. If you have for instance some subgroups with less than say 20 hours per week you might get an impossible timetable, probably because of incorrect division of years and incorrectly added activities. All the subgroups are independent. If you have a subgroup with only 2 hours per week and constraint early, then these 2 activities must be placed in the first hours of the day, which is probablymuch too hard (wrong).\n"
"\n"
"Important note: please do the correct division of a year from the beginning. Each time you divide a year, the corresponding activities and constraints referring to year's groups and subgroups will be removed, along with groups and subgroups. This is not elegant, I know, I will try to find a better solution in the future. If you already "
        "inputted a lot of constraints and activities referring to a year's groups/subgroups, you might want to manually change the division of a year by the groups/subgroups menus.\n"
"\n"
"Another possibility: you can see that each activity has allowed more teachers/students sets. If you need to split year Y according to Language1 (with teachers T1 and T2), you might not split Y and add an activity with Y and teachers T1 and T2 and subject \"Language1\". This is a small trick, which might be easier to use than to divide a year.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"\n"
"Q: What is the structure of the students FET can handle?\n"
"\n"
"A: FET was designed to allow any school structure:\n"
"\n"
"- independent subgroups (non-overlapping);\n"
"\n"
"- overlapping groups (several subgroups) and years (several groups).\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"\n"
"Q: How can one work with overlapping structur"
        "es of students?\n"
"\n"
"A: If you have overlapping groups, then you must define the smallest independent subgroup, which does not overlap with any other subgroup. Example: you have 1 group, subject sport (which must be taught to boys and girls separately) and subject physics, which is an optional subject and only some students would like to have this course (yes, FET can manage optional subjects). Then, you must define the subgroups: boys who want physics, boys who do not want physics, girls who want physics, girls who do not want physics. Now, it is very easy. Just define\n"
"\n"
"group girls=subgroup girls who want physics + girls who do not want physics,\n"
"\n"
"group boys=subgroup boys who want physics + boys who do not physics\n"
"\n"
"group physics=boys who want physics + girls who want physics.\n"
"\n"
"Then, you can add as many activities as you want to the corresponding groups:\n"
"\n"
"Activity1: teacher A, group girls, subject sport;\n"
"\n"
"Activity2: teacher B, group boys, subject sport;\n"
"\n"
""
        "Activity3: teacher C, group physics, subject optional physics.\n"
"\n"
"NEW: the thing can be also automated now. Select year->divide in the years dialog. Please see above entries in the FAQ.\n"
"\n"
"\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: Can you add more students sets or teachers to a single activity?\n"
"\n"
"A: Yes, you can add several students sets (subgroups, groups or years) and several teachers per activity.\n"
"\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"\n"
"Q: How can I contribute to/support FET?\n"
"\n"
"A: You can translate, improve interface, any work. Please email the author or mailing list for details.\n"
"\n"
"FET is free software and any donation would be great. Please contact the author for that.\n"
"\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"\n"
"Q: What advantages has FET over other applications?\n"
"\n"
"A: - It is fr"
        "ee software and...\n"
"\n"
"- Independent subgroups, overlapping or independent groups, overlapping or independent years (flexible enough to permit any kind of students structure). FET can even be used to manage every individual student, if you really need that;\n"
"\n"
"- Possibility of optional activities;\n"
"\n"
"- Many kinds of constraints, possibility to add many more (please suggest!).\n"
"\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"\n"
"Q: What are the disadvantages of FET, compared to other applications?\n"
"\n"
"A: - Very unfriendly (no help, primitive graphical user interface);\n"
"\n"
"- Potentially buggy. I do not have enough sample files for testing FET (and I hate testing :-)\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"\n"
"Q: Does FET compile on other operating systems than GNU/Linux?\n"
"\n"
"A: FET can be compiled easily in operating systems which are similar to GNU/Linux. I will provi"
        "de help to compile this program on any operating system. In particular, FET can be compiled on Microsoft Windows, if you install Qt from trolltech.com.\n"
"\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"\n"
"\n"
"Q: Does FET claim to be the best timetabling software in the world, like all the other timetabling applications?\n"
"\n"
"A: I cannot pretend that, because I could not compare FET with other applications (if you could help me, that would be great). All I can say right now is that I did not see any application with as many kinds of constraints and such flexibility as FET, and besides being free software.\n"
"\n"
"Is FET the first free timetabling software (GNU/GPL)? Hmmm... the first one was Tablix, as I found out after finishing FET. You can see links to this software if you look in the LINKS file or if you search it on the Internet.\n"
"\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"\n"
"Q: Help on"
        " ConstraintMinNDaysBetweenActivities.\n"
"\n"
"A: It refers to a set of activities and involves a constant, N. For every pair of activities in the set, it does not allow the distance(in days) between them to be less than N. If you specify N=1, then this constraint means that no two activities can be scheduled in the same day. N=2 means that each two activities must be separated by at least one day\n"
"\n"
"Example: 3 activities and N=2. Then, one can place them on Monday, Wednesday and Friday (5 days week).\n"
"\n"
"Example2: 2 activities, N=3. Then, one can place them on Monday and Thursday, on Monday and Friday, then on Tuesday and Friday (5 days week).\n"
"\n"
"The weight is recommended to be between 95.0%-100.0%. The best might be 99.75% or a value a little under 100%, because FET can detect impossible constraints this way and avoid them. The weight is subjective.\n"
"\n"
"You can specify consecutive if same day. Please be careful, even if constraint min n days between activities has 0% weight, if you sele"
        "ct this consecutive if same day, this consecutive will be forced. You will not be able to find a timetable with the two activities in the same day, separated by break, not available or other activities, even if the constraint has weight 0%, if you select consecutive if same day.\n"
"\n"
"Currently FET can put at most 2 activities in the same day if \"consecutive if same day\" is true. FET cannot put 3 or more activities in the same day if \"consecutive if same day\" is true.\n"
"\n"
"Important: please do not input unnecessary duplicates. If you input for instance 2 constraints:\n"
"1. Activities 1 and 2, min days 1, consecutive if same day=true, weight=95%\n"
"2. Activities 1 and 2, min days 1, consecutive if same day=false, weight=95%\n"
"(these are different constraints),\n"
"\n"
"then the outcome of these 2 constraints will be a constraint:\n"
"Activities 1 and 2, min days 1, consecutive if same day=true, weight=100%-5%*5%=99.75%, very high. This is because of FET algorithm.\n"
"\n"
"You may however add 2 c"
        "onstraints for the same activities if you want 100% with min 2 days and 95% with min 1 day. These are not duplicates.\n"
"\n"
"You might get an impossible timetable with duplicates, so beware.\n"
"\n"
"New, 14 June: if you need to balance 3 activities in a 5 days week, you can add, in the new version 5.5.8 and higher, directly from the add activity dialog, 2 constraints. You just have to input min days 2, and FET will ask if you want to add a second constraint with min days 1. This way, you can ensure that the activities are balanced better (at least one day apart, usually 2 days apart)\n"
"\n"
"------------------------------------------------------------------------------\n"
"\n"
"\n"
"Q: Can I use FET to do interactive timetabling?\n"
"\n"
"A: Yes, but this is not easy. All the part regarding data representation and gradually construction of the solution is working, only the interface has to be updated.\n"
"\n"
"Anyway, when you add a compulsory ConstraintActivityPreferredStartingTime, it means that you fixe"
        "d that activity. You can use this feature for a semi-automatic or even manual timetabling, but it is not so convenient.\n"
"\n"
"\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"\n"
"Q: After finding the timetable of our school, suppose that a single teacher needs to modify his timetable and the rest would like to keep their timetable unchanged. Thus, it is needed to fix all the activities of the rest of the teachers and re-allocate the hours. Can FET deal with such a situation?\n"
"\n"
"A: Yes, FET can deal with that. Just add many compulsory ConstraintActivityPreferredStartingTime-s, one for each activity that you would like to be fixed (the preferred time will be the one from the previous allocation).\n"
"\n"
"New (28 June 2008): The timetable can be saved as .fet file, with activities blocked, and you can unblock certain activities (of this teacher).\n"
"\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"\n"
""
        "Q: From Yush Yuen: Anyway, what i meant was, our teachers may have lunch at EITHER 5th or 6th period. so, i can't just use a break.\n"
"\n"
"A: From Volker Dirr: Just add a subject \"lunch\". Then add activities new activities. this activities must contain the teacher, subject lunch, split activity into number of working days of the teacher, set min n day = 100% and add NO studentsset. Then add constraint activities preferd time for this subject 5th and 6th hour weight = 100%.\n"
"\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: Is it possible to make a timetable where the students learn in two shifts? (for instance, the lowest form in the morning and the highest forms in the afternoon)?\n"
"\n"
"A: Yes, you have to add more constraint students set not available accordingly (for the lowest forms not available Mon, Tue, Wed, Th, Fr each from middle hour to last hour and for highest forms from first hour to middle hour). The constraints no gaps and early work "
        "correctly with these not available: if not available, a students set will not have gaps or early broken for the period of non-availability.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: What are groups of type \"year1 WHOLE YEAR\" and subgroups of type \"group1 WHOLE GROUP\"?\n"
"\n"
"A: FET old versions (prior to 5.4.17) inserted automatically them. Please remove them now.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: I added an activity with min days constraint. But I cannot see the min days value in modify activity dialog\n"
"\n"
"A: Min days is a time constraint. You can see it in the time constraints dialog\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: Can I work with fortnightly activities like in older FET versions?\n"
"\n"
"Answer modified 21 July 2008:\n"
"\n"
"A: You have to use some tricks. It would be difficult to consider fortnightly a"
        "ctivities into the new FET algorithm (from 5.0.0 up). But I think you can apply this: for instance, I suppose that you would like the first week to have activity A1 (teacher T1, student S1) and A2 (T2, S2), and second week A3 (T1, S2) and A4 (T2, S1) (simultaneously). You could define a weekly activity A (T1, T2, S1, S2). If you need 2 rooms for A, then you can define dummy A' (no teachers, no students) and constraint activities same starting time A and A' and add rooms for A and A' .\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: How to choose the weight percentage of constraint min n days between activities?\n"
"\n"
"A: You can use for the constraint min n days the weight you want. It can be 95%, 99%, 99.75% or even 100%, but please make sure your timetable is not too constrained. Please take care of the impossible constraints, they should have under 100% weight (percentage) - best would be 0%. For instance, if a teacher teaches only two days per week and"
        " has 3 math lessons for a group, then it is clear that the constraint cannot be respected, so the correct way is to specify under 100% weight (percentage) for the corresponding min n days constraint - best would be 0%.\n"
"\n"
"You could try at first the 95% minimum recommended value, then highten the weight percentage up to maybe 100%. I am not sure here, I have not enough sample files (please contribute with advice). If you would like to change the 95% for another value for all constraints of this type, the easiest way is in Data/Time constraints/Min n days between activities dialog, where starting with version 5.3.6 there is a simple command for that.\n"
"\n"
"You might want to choose different weights for different constraint min n days (for instance, higher on subjects with less activities per week)\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: Are some constraints more efficient in speed of generation than other constraints, even if they give the sam"
        "e result?\n"
"\n"
"A: From the way the algorithm is conceived, the automatic generation is faster if you use students set (or teacher) not available and/or constraint activity(ies) preferred time slots or constraint activity preferred starting time to specify impossible slots, in addition to possible use of students (set) or teacher(s) max hours daily, whenever it is possible. For instance, if you know that year 5 will only have hours from 8:00 to 13:00, it is better to add students set not available in addition to students set max hours daily. So, if possible, try to follow this advice. This trick helps guide FET better towards a solution.\n"
"\n"
"Each constraint of type not available or preferred times which filters out impossible slots might bring an improvement in speed.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: Is it allowed to use non-interger weights?\n"
"\n"
"A: If a constraint is allowed values under 100%, you can use any weight, even fractio"
        "nal numbers like 99.75%. It might help in constraints like min n days, preferred rooms or max hours daily.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: With max 5 hours per day and 2 max gaps per week, in 4 cases it resulted 3 lesson+2  gaps + 2 lesson that is not acceptable, cause other day only 2 lesson, I mean I don't want gaps on same day, and gaps only in extra cases extend the hours, how can I keep the balance in this?\n"
"\n"
"A: Then you have to add 2 extra activities for a teacher, each with duration 1 and students empty and dummy subject, and max gaps for this teacher 0.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: I have a sports room which allows more than 1 activity simultaneously in it. How to make the preferred room constraints? Can FET accept more than one activity at the same time in a single room?\n"
"\n"
"A: Each room can host a single activity at the same time. How to implement wh"
        "at you need? You can add more rooms (sport1, sport2, sport3) and instead of a single preferred room add more preferred rooms.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: Help me! I got an impossible to solve timetable\n"
"\n"
"A: If you get an impossible timetable, maybe the constraints students (set) early are too difficult. Maybe you can allow more arrivals at second hour. Also teachers' min hours daily might be too strong. Please also check the statistics to be correct. Remove other constraints until you get a possible timetable.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: Is it possible to work with 0 hour?\n"
"\n"
"A: A bit difficult. You have to choose a day for this 0 hour. Then add breaks or not available to prevent other activities in other days at hour 0, then add students set not available to prevent other students set from having hours at this hour 0. Or variants of this.\n"
"\n"
"Mr. Z"
        "solt Udvari used another trick: considered the last hour to be hour 0. But this is not always applicable.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: What is constraint teacher(s) min hours daily?\n"
"\n"
"A: If teachers are getting days with only one hour of work, you might want to add constraint teacher(s) min hours daily (probably with 2 hours), but please make sure your timetable is possible. This constraint is smart, it only considers non-empty days.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: How does FET care about weights. What do they mean?\n"
"\n"
"A: The weights under 100% are subjective, because FET can skip them if necessary.\n"
"\n"
"Mr Volker Dirr tried to express how FET considers under 100% weights, but his words are not completely reflecting the fact:\n"
"\n"
"Here is a comment from Mr. Volker Dirr:\n"
"weight = 50% means: In average FET retries two times to place an activity with"
        "out a conflict. If it isn\302\264t able to place the activity without a conflict after avarage 2 times it keeps the conflict and tries to place the next activity.\n"
"weight = 75% means: In average FET retries four times to place an activity without a conflict. If it isn\302\264t able to place the activity without a conflict after avarage 4 times it keeps the conflict and tries to place the next activity.\n"
"weight = 99% means: In average FET retries 100 times to place an activity without a conflict. If it isn\302\264t able to place the activity without a conflict after avarage 100 times it keeps the conflict and tries to place the next activity.\n"
"weight = 99.99% means: In average FET retries 10000 times to place an activity without a conflict. If it isn\302\264t able to place the activity without a conflict after avarage 10000 times it keeps the conflict and tries to place the next activity.\n"
"\n"
"This is not 100% correct. Activities might get unallocated, and cycle reopened.\n"
"\n"
"-----------------"
        "--------------------------------------------------------------\n"
"\n"
"Modified: 28 June 2008:\n"
"\n"
"Q: Help on constraint activities preferred starting or preferred time slots (a set of activities has a set of preferred starting or time slots)\n"
"\n"
"A: You can specify a set of activities by selecting a teacher (if empty - all teachers), a students set (if empty - all students), a subject (if empty - all subjects) and an activity tag (if empty, all activity tags) and a set of allowed days.\n"
"\n"
"Starting means that an activity may only start at these periods.\n"
"\n"
"Time slots means more restrictive, that activity may only start and end and take place in these intervals (if activity has duration 2 and on Monday is allowed 8:00, 9:00 and 10:00, then activity can only start at 8:00 or 9:00.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: Help on statistics menu\n"
"\n"
"A: The statistics are important to check your data before generating.\n"
"\n"
""
        "When seeing the students statistics, probably the most useful are for subgroups. Each subgroup should have a reasonable amount of hours, and if you are having subgroups with too little hours, like 2 per week, probably you misunderstood FET notation. Each subgroup is independent of the others and should have a number of hours per week close to the average of all subgroups. Do not input empty subgroups with only a few activities.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"Q: What if I enter accidentally duplicate constraints?\n"
"\n"
"A: It is not a good practice to allow unnecessary duplicate constraints. For min n days between activities and other constraints, the combined weight becomes very high. For instance, if you have 2 constraints with weight 95%, the outcome is a constraint with weight 100%-5%*5%=99.75%, very high. You might get an impossible timetable with duplicates, so beware. For constraint activity(ies) preferred (starting time(s) or time slot"
        "s) the chosen weight is the largest value, so you can use more constraints of this type for same activities.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New - Added 24 March 2008:\n"
"\n"
"Q: More information about students' structure\n"
"\n"
"A: The students' structure is very flexible and permits any institution structure.\n"
"\n"
"The main idea is that subgroups are independent. Each subgroup must be the smallest teaching unit or even a single student.\n"
"\n"
"The groups can contain any subgroups. The groups can be overlapping.\n"
"\n"
"The years can contain any groups.\n"
"\n"
"You do not need to follow exactly your institution's hierarchy, you can model your structure to be able to use FET better.\n"
"\n"
"Example: you have a faculty with years (1, 2, ..., 5), sections (1_a, 1_b, ...) and subsections (1_a_x, 1_a_y, ...). Each subsection has optional English or French or German languages (say, a students set who takes English is ENG, and who does not t"
        "ake English is !ENG). Then the correct structure is:\n"
"\n"
"subgroups\n"
"	1_a_x_ENG_FRE_GER,\n"
"	1_a_x_!ENG_FRE_GER,\n"
"	1_a_x_ENG_!FRE_GER,\n"
"	1_a_x_!ENG_!FRE_GER, \n"
"	1_a_x_ENG_FRE_!GER,\n"
"	1_a_x_!ENG_FRE_!GER,\n"
"	1_a_x_ENG_!FRE_!GER,\n"
"	1_a_x_!ENG_!FRE_!GER, \n"
"\n"
"	1_a_y_ENG_FRE_GER,\n"
"	...same for 1_a_y (8 subgroups)\n"
"\n"
"(you can consider not adding empty subgroups, for instance if every student has one single language, then you can retain only 3 subgroups out of 8)\n"
"\n"
"groups:\n"
"	1_a\n"
"		contains subgroups:\n"
"			1_a_x_ENG_FRE_GER,\n"
"			1_a_x_!ENG_FRE_GER,\n"
"			1_a_x_ENG_!FRE_GER,\n"
"			1_a_x_!ENG_!FRE_GER, \n"
"			1_a_x_ENG_FRE_!GER,\n"
"			1_a_x_!ENG_FRE_!GER,\n"
"			1_a_x_ENG_!FRE_!GER,\n"
"			1_a_x_!ENG_!FRE_!GER, \n"
"\n"
"			1_a_y_ENG_FRE_GER,\n"
"			...same for 1_a_y (8 subgroups)\n"
"\n"
"	1_a_x\n"
"		contains subgroups:\n"
"			1_a_x_ENG_FRE_GER,\n"
"			1_a_x_!ENG_FRE_GER,\n"
"			1_a_x_ENG_!FRE_GER,\n"
"			1_a_x_!ENG_!FRE_GER, \n"
"			1_a_x_ENG_FRE_!GER,\n"
""
        "			1_a_x_!ENG_FRE_!GER,\n"
"			1_a_x_ENG_!FRE_!GER,\n"
"			1_a_x_!ENG_!FRE_!GER, \n"
"\n"
"	1_a_y\n"
"		contains subgroups:\n"
"			1_a_y_ENG_FRE_GER,\n"
"			... (8 subgroups)\n"
"\n"
"	1_a_x_ENG\n"
"		contains subgroups:\n"
"			1_a_x_ENG_FRE_GER,\n"
"			1_a_x_ENG_!FRE_GER,\n"
"			1_a_x_ENG_FRE_!GER,\n"
"			1_a_x_ENG_!FRE_!GER\n"
"\n"
"years:\n"
"	1\n"
"		contains groups 1_a, 1_b\n"
"\n"
"You will have the possibility to add any activity, for a year or group\n"
"\n"
"Currently, the interface for students is difficult to use. I am thinking of that. Maybe it is more simple for you if you try to work on the xml .fet file.\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New - Added 27 March 2008: (Q-1-27-March-2008)\n"
"\n"
"Q: Example: I have 7 hours of Maths per 5 days week (7 is larger than 5). How to add correctly this split activity?\n"
"\n"
"Complete Question: I have a large container activity split into more activities than the number of days per week. How to add "
        "it and constraint min n days between activities?\n"
"\n"
"A: If you add directly a container activity split into more than the number of days per week and also add a constraint min n days between activities, it would be a very bad practice from the way the algorithm of generation works (it slows down the generation and makes it harder to find a solution).\n"
"\n"
"The best way to add the activities would be:\n"
"\n"
"1. If you add 'force consecutive if same day', then couple extra activities in pairs to obtain a number of activities equal to the number of days per week. Example: 7 activities with duration 1 in a 5 days week, then transform into 5 activities with durations: 2,2,1,1,1 and add a single container activity with these 5 components (possibly raising the weight of added constraint min n days between activities up to 100%)\n"
"\n"
"2. If you don't add 'force consecutive if same day', then add a larger activity splitted into a number of activities equal with the number of days per week and the remaining"
        " components into other larger splitted activity. For example, suppose you need to add 7 activities with duration 1 in a 5 days week. Add 2 larger container activities, first one splitted into 5 activities with duration 1 and second one splitted into 2 activities with duration 1 (possibly raising the weight of added constraints min n days between activities for each of the 2 containers up to 100%)\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New - Added 6 June 2008: (Q-1-6-June-2008)\n"
"\n"
"Q: What I need is a way to make the following constraint:\n"
"\n"
"If Activity1 comes first, then Activity2 can be consecutive\n"
"But, if Activity2 comes first,  then Activity1 must have at least 1 period in between.\n"
"\n"
"For example, if the algorithm places Dance in 1st hour, then Wrestling can be placed in 2nd hour, but if Wrestling is placed in 1st hour, then Dance must be at least in 3rd hour, if not farther away.\n"
"\n"
"A simpler, but less useful solution cou"
        "ld be a constraint that says:\n"
"\n"
"Activity1 and Activity2 will not be consecutive.  \n"
"\n"
"A: I have a very good solution for you, but it is a bit complicated to add.\n"
"\n"
"Suppose you have activities A1 and A2. Add dummy A3, with duration 1, no teachers and no students. Add constraint 2 activities consecutive, A2 and A3 (A2 followed by A3). Add constraint activities not overlapping, A1 and A3.\n"
"\n"
"There is only a small problem: A2 cannot be put in the last period. To correct that: increase the number of hours with 1 and constraint all the real activities (without A3) to take place in the first periods. You can do that by adding a subject tag to A1 and A2 named Early and a subject tag to A3 named Any, and constraint activities preferred time slots for subject tag Early to be in the first n-1 slots of each day.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New - Added 14 June 2008: it was added a possibility to add 2 constraints min n days betw"
        "een activities when adding a split activity. Please read above the documentation related to constrain min n days between activities (basically, if you add min days 2 (or 3), you get the possibility to add a second constraint with min days 1 (or 2).\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New - Added 28 June 2008: \n"
"\n"
"Q: What is the difference between preferred starting times and preferred time slots?\n"
"\n"
"A: Time slots is more restrictive, means all hours of an activity must be in the allowed intervals.\n"
"\n"
"Example: Preferred times Monday 8,9 and 10. If activity A has duration 2, then starting means that activity A can start at 8, 9 or 10 on Monday, while overall means that activity A can start on Monday at 8 or 9 (10 is not allowed, because the last hour of activity is not allowed there).\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New - Added 10 July 2008: \n"
"\n"
"Q: What means con"
        "straint min gaps (hours) between a set of activities?\n"
"\n"
"A: I had many users wanting to put a gap between activities of same teachers or between activities with same teacher and subject, if they are on the same day. This constraint does that. If you want for instance to make teacher John to have at least one gap between all his activities, select filter \"John\" and add all his activities to a constraint of this type. If you want to make teacher John to have at least one gap between all his Math activities, select filter \"John\" and \"Math\" and add all these activities to a constraint of this type.\n"
"\n"
"Please take care that the selected activities are not forced consecutive by constraint 2 activities consecutive or by constraint min n days between activities which have consecutive if same day selected.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New - Added 11 July 2008: \n"
"\n"
"Q: As most of our pupils are using special busses, the last less"
        "on of the day must be at least the 5th (of 6 lessons). Year 10 for instance has 2 allowed beginnings of second hour, with 27 working hours in 5x6 hours per week.\n"
"\n"
"A: It is possible to add constraint students min 5 hours daily, but this is stronger that what you need, so the timetable is more difficult to generate (year 10 might have 4 hours on a day: 1:not here, 2: math, 3: phys, 4: engl, 5: bio, 6: not here on a normal timetable).\n"
"\n"
"It is possible to use some trick, if you cannot find a solution with minimum 5 hours per day: add, for each lowest level set of year 10 (see * below), 3 dummy activities, which represent the max 2 beginnings at second hour and the minimum 1 finishing at the 5th period (2+1=3). The first 2 activities have activity tag ATBegin and last 1 activity ATEnd. Add 2 constraints a set of activities has a set of preferred time slots, ATBegin, first hour each day and last hour of each day allowed and rest not allowed and ATEnd, allowed only at last slot of each day. Optionally:"
        " add constraint students (set) early max begs at sec. hour = 0 for the involved students (may use here year or group). I think it should work nice, but you have to work a little bit more to input the data.\n"
"\n"
"* : if year 10 does not contain groups, add dummy activities for year 10. If year 10 contains only groups, add for each group. If year 10 contains subgroups, add for each subgroup. The reason: if year 10 contains subgroups and you add dummy activity, it is constrained to be in the same time for all subgroups; if you add dummy activities for subgroups, they can be in different slots -> timetable might be easier to find.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New - Added 15 July 2008: \n"
"\n"
"From Zsolt Udvari:\n"
"\n"
"Q: * imho must have a constraint: a student (or set) must have activite\n"
"at specified time /because in our school there is a worship in church\n"
"at monday, 7:30, and the school begin at 8:00 - so every students must\n"
""
        "have an activite monday's first hour - and there is a class, where\n"
"must be an \"empty\" first hour).\n"
"\n"
"he problem (exactly): there's a class, 5A (11-12 years old), and\n"
"they've 4 english hours, in two subgroups (5A1 and 5A2), with same(!)\n"
"teacher (DIOR). They'll learn the other language (latin) in this\n"
"subgroups, but they've \"only\" 3 latin. And at the other hours they're\n"
"together. So if we don't want gaps we must the english and latin hours\n"
"be pair, and one english hour'll be alone.\n"
"But these students are young so must escort them to lunch and can't be\n"
"that they'll go in two subgroups to lunch.\n"
"So, once the 5A1 hasn't first hour and 5A2 has english lesson and\n"
"second vica versa (when we don't want gaps). But in monday...\n"
"\n"
"3 answers by Liviu:\n"
"\n"
"A1: Maybe you could use dummy activities to represent gaps at first hour. Say you \n"
"allow 2 gaps at first hour, not on Monday. Then add a dummy activity for each \n"
"subgroup (with subject tag ST) and acti"
        "vities preferred starting times \n"
"subject tag ST allowed Tuesday first hour, Wed first hour, Th first hour, Fr \n"
"first hour. It should work.\n"
"\n"
"Also allowed on the last slot of each day. But if you can have 2 last empty \n"
"slots in a day, I think you cannot use this trick.\n"
"\n"
"A2: I understand that you want to allow 1 arrival at second hour, not on Monday.\n"
"\n"
"So, add hours+1: 7:30, 8, ...\n"
"\n"
"Add not available for each students set (or break - for all) on Tue, Wed, Thu, \n"
"Fri, at hour 7:30.\n"
"\n"
"Add 1 activity Religion, all students, no teachers. Preferred starting time \n"
"Mon 7:30 (or you can add more activities).\n"
"\n"
"Add constraint activity (one or more, as you added one or more Religion), \n"
"Monday, 7:30, for the above activity/ies.\n"
"\n"
"Add constraint students early max 1 beginning at second hour.\n"
"\n"
"A3: Constraint activities preferred time slots creates gaps, so use this facility:\n"
"\n"
"Add hours from 7:30.\n"
"\n"
"Constraint activities preferred"
        " time slots, not allowed on Monday 7:30, 100%.\n"
"\n"
"Constraint break times (or not available for all students), not allowed Tue, \n"
"Wed, Thu, Fri 7:30.\n"
"\n"
"Add constraint students early max 2 beginnings at second hour (max 2 \n"
"beginnings, not 1, careful, because the Monday 7:30 is one and you allow \n"
"another one).\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New - Added 15 July 2008: \n"
"\n"
"Q: What type of files uses FET?\n"
"\n"
"A: FET uses text files, xml or html or txt or csv (comma separated values - for import/export). The used codec is UTF-8 and probably UTF-16 should work.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New, added 4 August 2008:\n"
"\n"
"Q: Help on constraint subactivities preferred starting or preferred time slots (a set of subactivities has a set of preferred starting or time slots)\n"
"\n"
"A: You select the component number of certain activities (say, if you ha"
        "ve an activity split into 5 activities per week, you have components 1, 2, 3, 4 or 5. Only the selected number of this split activity (the corresponding component activity) will be constrained.\n"
"\n"
"You will also specify the set of subactivities by selecting a teacher (if empty - all teachers), a students set (if empty - all students), a subject (if empty - all subjects) and an activity tag (if empty, all activity tags) and a set of allowed days.\n"
"\n"
"Starting times means that an activity may only start at these periods.\n"
"\n"
"Time slots means more restrictive, that activity may only start and end and take place in these intervals (if activity has duration 2 and on Monday is allowed 8:00, 9:00 and 10:00, then activity can only start at 8:00 or 9:00.\n"
"\n"
"This is useful if you need for instance, if Maths lessons are 4-5 per week, to constrain that the first component and the second component must be early. You will add 2 constraints for that, with component number 1 and 2, both with subject Maths"
        ". Or, if you want for activities split into 4 that 2 lessons are early and for activities split into 5 that 3 activities are early, add constraint Maths with split number 3, 4 and 5 (nice trick).\n"
"\n"
"Another thing: if you have 1 or 2 lessons per week for a subject, say biology, and want to constrain one of the components if there are 2 per week, and none if there is only 1, you can add such a constraint for component number=2.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New, added 15 August 2008:\n"
"\n"
"Q: Help on constraints teacher(s) or students (set) hourly interval max days per week\n"
"\n"
"A: This is a constraint suggested by users, to allow you to specify an hourly interval for students or teachers, and to say that in this interval they must work at most max days per week. This is useful if for instance you want teachers not to have more than 2 days per week activities in the last 2 hours of the day.\n"
"\n"
"---------------------------------"
        "----------------------------------------------\n"
"\n"
"New, added 16 August 2008:\n"
"\n"
"Q: Help on constraint activities end students day (or activity ends students day).\n"
"\n"
"A: If you have activities which you want to put in the last slots of a day (like say the meetings with the class master), please use the new constraint a set of activities end students day (or singular activity ends students day). This constraint can have weight only 100%, because of the way the algorithm works.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New, added 16 August 2008:\n"
"\n"
"Q: At our school there are a lot of teachers which work only a few hours a week. Of course it is really nasty to drive for one our to the school. So we  set the constraint, that every teacher should work at least 2 hours a day. Unfortunately we have this year a teacher which only works 1h a week. As a result of this FET doesn't start to create a timetable. Any suggestions how to fix the pro"
        "blem without defining a constraint for every singular teacher?\n"
"\n"
"A: I have a nice trick: add a dummy activity, 1 hour duration, with only this teacher (no students sets, any subject), additional to the real activity.\n"
"\n"
"This trick just passed through my mind as I was trying to write you that you have to do it the hard way (add constraints for each teacher)\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New, added 17 August 2008:\n"
"\n"
"Q: What about the automatic search for updates? Should I enable it?\n"
"\n"
"A: It is recommended to enable automatic search for updates. I didn't set it as default because people might be annoyed if I release too fast new versions. But if you can cope with that, it is recommended to always have the latest version and enable searching for updates at startup.\n"
"\n"
"-------------------------------------------------------------------------------\n"
"\n"
"New, added 30 August 2008:\n"
"\n"
"Q: From Q.D.John:\n"
"\n"
""
        "> you might think about a very powerful new\n"
"> feature: Schools like ours which educate young teachers have to place some\n"
"> lessons of one subject in a special class with both, the trainee and the\n"
"> trainer, for instance: The trainee \"scf\" has to have six lessons \"German\"\n"
"> in \"4a\" (2,1,1,1,1), in one of these single lessons (1+1,1,1,1,1) she has\n"
"> to be attended by the trainer \"fri\". I got many problems in putting in\n"
"> this, so we had to create a workaround, that does not work really good (as\n"
"> you may see from my data, that I'll send later on). Best would be to have\n"
"> two more fields in the \"input activity screen\": 1-attendng teacher(s)\n"
"> 2-number of single lessons to be attended. - Is this challenging ?\n"
"\n"
"A: I suggest 2 simple alternative approaches:\n"
"\n"
"1) The interface does not allow to specify different teachers for a larger \n"
"split activity. But you can modify manually the .fet data file and add one additional \n"
"teacher in a component.\n"
"\n"
""
        "2) For working only in the GUI: for instance, you have activity A, split into \n"
"A1, A2, A3, A4 and A5. Then, consider instead activities Aa, split into Aa1, \n"
"Aa2, Aa3 and Aa4, with teacher T1 (do not add here a constraint min n days \n"
"between activities), and Ab, one component, with teachers T1 and T2. Add a \n"
"constraint min n days between activities, Aa1, Aa2, Aa3, Aa4 and Ab.\n"
"\n"
"---------------------------------------------------------------------------------\n"
"\n"
"New, added 5 September 2008, modified a bit 25 September 2008:\n"
"\n"
"Q - Q1-5-September-2008: From juancmar:\n"
"\n"
"Hi, normative for High-School in Spain specifies that if an activity is scheduled in 3 periods in a week, they can't be in three consecutive days. So if I set min n days between activities as 1, then sometimes I get the 3 activities in consecutive days. If I set it as 2, then a restriction must be broken as I only have 5 days and not always can be used Monday, Wednesday and Friday. Then sometimes I got two "
        "of these activities the same day.\n"
"\n"
"How can I do these 3 days activities not being in three consecutive days? (I'd like to schedule two of them in consecutive days, and the other one two days after, or Monday, Wednesday and Friday)\n"
"\n"
"A: More solutions possible:\n"
"\n"
"1) the perfect solution, which is a bit difficult to implement: say A1, A2, A3 are the activities. Add constraint min n days between activities A1, A2 and A3 (if not already added), 100%, 1 day, constraint min n days between activities A1 and A3, 2 days, 100% and between A2 and A3, 2 days, 100%.\n"
"\n"
"2) add a constraint min n days between activities for A1, A2 and A3, min days 1, weight 100%. Then add a second constraint min n days between activities, A1, A2, A3, min days 2, weight somewhere from 50% to 95% or even 99.75% if it is possible.\n"
"From the add activity interface, you can add min days 2 and FET will ask about a second constraint, with min days 1, so you can add them directly from add activity dialog.\n"
"\n"
"Also"
        ", you can change multiple constraints at once from the min n days constraints dialog, using an intelligent filter.\n"
"\n"
"\n"
"---------------------------------------------------------------------------------\n"
"\n"
"New, added 6 October 2008\n"
"\n"
"Q: By law a teacher in Italy must work not less of 5 days a week\n"
"\n"
"A: You might use this trick: add for each teacher a dummy container (larger) activity, with no students, split into 5 activities per week, with constraint min 1 day between activities 100%. Then, constraint teachers min hours daily, min 2 hours (for minimum 1 real hour) or min 3 hours (for minimum 2 real hours).\n"
"\n"
"---------------------------------------------------------------------------------\n"
"\n"
"New, added 5 December 2008\n"
"\n"
"Q: I have a double duration activity. Is it possible that it is spread over the break period, like:\n"
"\n"
"Activity Math, duration 2, id say 100\n"
"\n"
"Hour 10:00 Math (first hour of act. 100)\n"
"Hour 11:00 Break\n"
"Hour 12:00 Math (second "
        "hour of act. 100)\n"
"\n"
"A: No, the activity must respect the break, so it is before or after the break with all the hours of it.", 0, QApplication::UnicodeUTF8));
    Q_UNUSED(HelpFaqForm_template);
    } // retranslateUi

};

namespace Ui {
    class HelpFaqForm_template: public Ui_HelpFaqForm_template {};
} // namespace Ui

QT_END_NAMESPACE

class HelpFaqForm_template : public QDialog, public Ui::HelpFaqForm_template
{
    Q_OBJECT

public:
    HelpFaqForm_template(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~HelpFaqForm_template();

protected slots:
    virtual void languageChange();

};

#endif // HELPFAQFORM_TEMPLATE_H
