#ifndef HELPTIPSFORM_TEMPLATE_H
#define HELPTIPSFORM_TEMPLATE_H

#include <qvariant.h>


#include <Qt3Support/Q3MimeSourceFactory>
#include <Qt3Support/Q3TextBrowser>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QPushButton>

QT_BEGIN_NAMESPACE

class Ui_HelpTipsForm_template
{
public:
    QGridLayout *gridLayout;
    QPushButton *closePushButton;
    Q3TextBrowser *textBrowser3_2;

    void setupUi(QDialog *HelpTipsForm_template)
    {
    if (HelpTipsForm_template->objectName().isEmpty())
        HelpTipsForm_template->setObjectName(QString::fromUtf8("HelpTipsForm_template"));
    HelpTipsForm_template->resize(540, 439);
    gridLayout = new QGridLayout(HelpTipsForm_template);
    gridLayout->setSpacing(6);
    gridLayout->setMargin(11);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    closePushButton = new QPushButton(HelpTipsForm_template);
    closePushButton->setObjectName(QString::fromUtf8("closePushButton"));

    gridLayout->addWidget(closePushButton, 1, 0, 1, 1);

    textBrowser3_2 = new Q3TextBrowser(HelpTipsForm_template);
    textBrowser3_2->setObjectName(QString::fromUtf8("textBrowser3_2"));

    gridLayout->addWidget(textBrowser3_2, 0, 0, 1, 1);


    retranslateUi(HelpTipsForm_template);
    QObject::connect(closePushButton, SIGNAL(clicked()), HelpTipsForm_template, SLOT(close()));

    QMetaObject::connectSlotsByName(HelpTipsForm_template);
    } // setupUi

    void retranslateUi(QDialog *HelpTipsForm_template)
    {
    HelpTipsForm_template->setWindowTitle(QApplication::translate("HelpTipsForm_template", "FET - important tips", 0, QApplication::UnicodeUTF8));
    closePushButton->setText(QApplication::translate("HelpTipsForm_template", "Close", 0, QApplication::UnicodeUTF8));
    textBrowser3_2->setText(QApplication::translate("HelpTipsForm_template", "FET Important optimization tips - please read them carefully and try to comply\n"
"Modified 15 June 2008.\n"
"\n"
"1) Say you add a split activity or you add a constraint min n days between activities (say na activities), when your week has nd days. Do not add a constraint with na>nd (number of activities strictly greater than number of days per week).\n"
"\n"
"The correct way: if you want consecutive if same day, consider activities having a longer duration. Instead of adding activities 1+1+1+1+1+1+1 in a 5 days week, add them as 2+2+1+1+1. If you don't want consecutive if same day, add 1+1+1+1+1 firstly and 1+1 after that.\n"
"\n"
"The generation will be much faster and easier using this approach (more than 10 times faster sometimes).\n"
"\n"
"2) When adding constraints activities same starting time (or day), please remove redundant min n days constraints. For instance, A1 (at same time with B1 and C1), A2 (same time with B2 and C2) and A3 (same time with B3 and C3). You will normally have 3 or 6 constraints"
        " min n days between activities (first one or two with A1,A2,A3 and then with B1,B2,B3 and then with C1,C2,C3). These 3 or 6 constraints min n days will result in a much stronger constraint, which will make the timetable much harder to find. If you have say 4 groups of activities (A, B, C, D), things will be even harder.\n"
"\n"
"The correct way is to leave only the constraints min n days referring to the first group of activities (A). You will have a much faster generation (maybe 10 times faster or more).\n"
"\n"
"PS: Suppose there are 2 constraints for activities A1,2,3 and 2 constraints for activities B1,2,3 and 2 constraints for activities C1,2,3. If A and B and C are simultaneous, remove only the constraints referring to B and C (but leave both for A, if for instance you have min 2 days with 95% and min 1 day with 100%).\n"
"\n"
"More details: the combination of 2 or more redundant constraints min n days between activities gives another resultant constraint, much stronger. From 3 redundant constraints with"
        " 95%, you get one with 100%-5%*5%*5%=99.9875%, which is not what you want.\n"
"\n"
"Do not consider redundant constraints with the same activities but different number of days (you may want to add min 2 days 95% and min 1 day 95%, which gives in 95% cases the 2 days will be respected and in 99.75% cases the 1 day will be respected).\n"
"\n"
"The other constraints (like preferred time(s) constraints) do not have the problem of redundancy like min days constraints, so no need to take care about them.\n"
"\n"
"It is IMPORTANT to remove redundant min n days constraints after you inputted data and before generating. Any modification of the min n days constraints should be followed by this removal of redundant min n days constraints (well, not all modifications, but better to do it than not). If you modify more constraints at once or apply the balancing of activities, it is important to remove redundant constraints. If you have no redundant constraints, it is no need to remove the redundant constraints, but better t"
        "o check again than let some redundant constraints active.", 0, QApplication::UnicodeUTF8));
    Q_UNUSED(HelpTipsForm_template);
    } // retranslateUi

};

namespace Ui {
    class HelpTipsForm_template: public Ui_HelpTipsForm_template {};
} // namespace Ui

QT_END_NAMESPACE

class HelpTipsForm_template : public QDialog, public Ui::HelpTipsForm_template
{
    Q_OBJECT

public:
    HelpTipsForm_template(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~HelpTipsForm_template();

protected slots:
    virtual void languageChange();

};

#endif // HELPTIPSFORM_TEMPLATE_H
