#ifndef ROOMSFORM_TEMPLATE_H
#define ROOMSFORM_TEMPLATE_H

#include <qvariant.h>


#include <Qt3Support/Q3ListBox>
#include <Qt3Support/Q3MimeSourceFactory>
#include <Qt3Support/Q3TextEdit>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>

QT_BEGIN_NAMESPACE

class Ui_RoomsForm_template
{
public:
    QGridLayout *gridLayout;
    QPushButton *addRoomPushButton;
    QPushButton *removeRoomPushButton;
    QPushButton *closePushButton;
    QPushButton *sortRoomsPushButton;
    QPushButton *modifyRoomPushButton;
    Q3ListBox *roomsListBox;
    Q3TextEdit *currentRoomTextEdit;
    QLabel *textLabel1;

    void setupUi(QDialog *RoomsForm_template)
    {
    if (RoomsForm_template->objectName().isEmpty())
        RoomsForm_template->setObjectName(QString::fromUtf8("RoomsForm_template"));
    RoomsForm_template->resize(510, 542);
    gridLayout = new QGridLayout(RoomsForm_template);
    gridLayout->setSpacing(6);
    gridLayout->setMargin(11);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    addRoomPushButton = new QPushButton(RoomsForm_template);
    addRoomPushButton->setObjectName(QString::fromUtf8("addRoomPushButton"));

    gridLayout->addWidget(addRoomPushButton, 3, 0, 1, 1);

    removeRoomPushButton = new QPushButton(RoomsForm_template);
    removeRoomPushButton->setObjectName(QString::fromUtf8("removeRoomPushButton"));

    gridLayout->addWidget(removeRoomPushButton, 3, 1, 1, 1);

    closePushButton = new QPushButton(RoomsForm_template);
    closePushButton->setObjectName(QString::fromUtf8("closePushButton"));

    gridLayout->addWidget(closePushButton, 5, 0, 1, 2);

    sortRoomsPushButton = new QPushButton(RoomsForm_template);
    sortRoomsPushButton->setObjectName(QString::fromUtf8("sortRoomsPushButton"));

    gridLayout->addWidget(sortRoomsPushButton, 4, 1, 1, 1);

    modifyRoomPushButton = new QPushButton(RoomsForm_template);
    modifyRoomPushButton->setObjectName(QString::fromUtf8("modifyRoomPushButton"));

    gridLayout->addWidget(modifyRoomPushButton, 4, 0, 1, 1);

    roomsListBox = new Q3ListBox(RoomsForm_template);
    roomsListBox->setObjectName(QString::fromUtf8("roomsListBox"));

    gridLayout->addWidget(roomsListBox, 2, 0, 1, 1);

    currentRoomTextEdit = new Q3TextEdit(RoomsForm_template);
    currentRoomTextEdit->setObjectName(QString::fromUtf8("currentRoomTextEdit"));
    currentRoomTextEdit->setReadOnly(true);

    gridLayout->addWidget(currentRoomTextEdit, 2, 1, 1, 1);

    textLabel1 = new QLabel(RoomsForm_template);
    textLabel1->setObjectName(QString::fromUtf8("textLabel1"));
    textLabel1->setWordWrap(false);

    gridLayout->addWidget(textLabel1, 0, 0, 1, 2);

    QWidget::setTabOrder(roomsListBox, currentRoomTextEdit);
    QWidget::setTabOrder(currentRoomTextEdit, addRoomPushButton);
    QWidget::setTabOrder(addRoomPushButton, removeRoomPushButton);
    QWidget::setTabOrder(removeRoomPushButton, modifyRoomPushButton);
    QWidget::setTabOrder(modifyRoomPushButton, sortRoomsPushButton);
    QWidget::setTabOrder(sortRoomsPushButton, closePushButton);

    retranslateUi(RoomsForm_template);
    QObject::connect(addRoomPushButton, SIGNAL(clicked()), RoomsForm_template, SLOT(addRoom()));
    QObject::connect(removeRoomPushButton, SIGNAL(clicked()), RoomsForm_template, SLOT(removeRoom()));
    QObject::connect(roomsListBox, SIGNAL(highlighted(int)), RoomsForm_template, SLOT(roomChanged(int)));
    QObject::connect(closePushButton, SIGNAL(clicked()), RoomsForm_template, SLOT(close()));
    QObject::connect(modifyRoomPushButton, SIGNAL(clicked()), RoomsForm_template, SLOT(modifyRoom()));
    QObject::connect(sortRoomsPushButton, SIGNAL(clicked()), RoomsForm_template, SLOT(sortRooms()));
    QObject::connect(roomsListBox, SIGNAL(selected(QString)), RoomsForm_template, SLOT(modifyRoom()));

    QMetaObject::connectSlotsByName(RoomsForm_template);
    } // setupUi

    void retranslateUi(QDialog *RoomsForm_template)
    {
    RoomsForm_template->setWindowTitle(QApplication::translate("RoomsForm_template", "Rooms", 0, QApplication::UnicodeUTF8));
    addRoomPushButton->setText(QApplication::translate("RoomsForm_template", "Add room", 0, QApplication::UnicodeUTF8));
    removeRoomPushButton->setText(QApplication::translate("RoomsForm_template", "Remove current", 0, QApplication::UnicodeUTF8));
    closePushButton->setText(QApplication::translate("RoomsForm_template", "Close", 0, QApplication::UnicodeUTF8));
    sortRoomsPushButton->setText(QApplication::translate("RoomsForm_template", "Sort by name", 0, QApplication::UnicodeUTF8));
    modifyRoomPushButton->setText(QApplication::translate("RoomsForm_template", "Modify current", 0, QApplication::UnicodeUTF8));
    roomsListBox->clear();
    roomsListBox->insertItem(QApplication::translate("RoomsForm_template", "New Item", 0, QApplication::UnicodeUTF8));
    textLabel1->setText(QApplication::translate("RoomsForm_template", "NOTE: each room can hold a single activity at the same time\n"
"(you can add more rooms representing a very large room)", 0, QApplication::UnicodeUTF8));
    Q_UNUSED(RoomsForm_template);
    } // retranslateUi

};

namespace Ui {
    class RoomsForm_template: public Ui_RoomsForm_template {};
} // namespace Ui

QT_END_NAMESPACE

class RoomsForm_template : public QDialog, public Ui::RoomsForm_template
{
    Q_OBJECT

public:
    RoomsForm_template(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~RoomsForm_template();

public slots:
    virtual void addRoom();
    virtual void removeRoom();
    virtual void roomChanged(int);
    virtual void roomsEquipments();
    virtual void sortRooms();
    virtual void modifyRoom();
    virtual void filterChanged();

protected slots:
    virtual void languageChange();

};

#endif // ROOMSFORM_TEMPLATE_H
