#ifndef TEACHERSFORM_TEMPLATE_H
#define TEACHERSFORM_TEMPLATE_H

#include <qvariant.h>


#include <Qt3Support/Q3ListBox>
#include <Qt3Support/Q3MimeSourceFactory>
#include <Qt3Support/Q3TextEdit>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QPushButton>

QT_BEGIN_NAMESPACE

class Ui_TeachersForm_template
{
public:
    QGridLayout *gridLayout;
    QPushButton *addTeacherPushButton;
    QPushButton *removeTeacherPushButton;
    QPushButton *sortTeachersPushButton;
    Q3ListBox *teachersListBox;
    Q3TextEdit *currentTeacherTextEdit;
    QPushButton *closePushButton;
    QPushButton *renameTeacherPushButton;
    QPushButton *activateTeacherPushButton;
    QPushButton *deactivateTeacherPushButton;

    void setupUi(QDialog *TeachersForm_template)
    {
    if (TeachersForm_template->objectName().isEmpty())
        TeachersForm_template->setObjectName(QString::fromUtf8("TeachersForm_template"));
    TeachersForm_template->resize(656, 536);
    gridLayout = new QGridLayout(TeachersForm_template);
    gridLayout->setSpacing(6);
    gridLayout->setMargin(11);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    addTeacherPushButton = new QPushButton(TeachersForm_template);
    addTeacherPushButton->setObjectName(QString::fromUtf8("addTeacherPushButton"));

    gridLayout->addWidget(addTeacherPushButton, 1, 0, 1, 1);

    removeTeacherPushButton = new QPushButton(TeachersForm_template);
    removeTeacherPushButton->setObjectName(QString::fromUtf8("removeTeacherPushButton"));

    gridLayout->addWidget(removeTeacherPushButton, 1, 1, 1, 1);

    sortTeachersPushButton = new QPushButton(TeachersForm_template);
    sortTeachersPushButton->setObjectName(QString::fromUtf8("sortTeachersPushButton"));

    gridLayout->addWidget(sortTeachersPushButton, 2, 1, 1, 1);

    teachersListBox = new Q3ListBox(TeachersForm_template);
    teachersListBox->setObjectName(QString::fromUtf8("teachersListBox"));

    gridLayout->addWidget(teachersListBox, 0, 0, 1, 1);

    currentTeacherTextEdit = new Q3TextEdit(TeachersForm_template);
    currentTeacherTextEdit->setObjectName(QString::fromUtf8("currentTeacherTextEdit"));
    currentTeacherTextEdit->setReadOnly(true);

    gridLayout->addWidget(currentTeacherTextEdit, 0, 1, 1, 1);

    closePushButton = new QPushButton(TeachersForm_template);
    closePushButton->setObjectName(QString::fromUtf8("closePushButton"));

    gridLayout->addWidget(closePushButton, 4, 0, 1, 1);

    renameTeacherPushButton = new QPushButton(TeachersForm_template);
    renameTeacherPushButton->setObjectName(QString::fromUtf8("renameTeacherPushButton"));

    gridLayout->addWidget(renameTeacherPushButton, 2, 0, 1, 1);

    activateTeacherPushButton = new QPushButton(TeachersForm_template);
    activateTeacherPushButton->setObjectName(QString::fromUtf8("activateTeacherPushButton"));

    gridLayout->addWidget(activateTeacherPushButton, 3, 0, 1, 1);

    deactivateTeacherPushButton = new QPushButton(TeachersForm_template);
    deactivateTeacherPushButton->setObjectName(QString::fromUtf8("deactivateTeacherPushButton"));

    gridLayout->addWidget(deactivateTeacherPushButton, 3, 1, 1, 1);

    QWidget::setTabOrder(teachersListBox, addTeacherPushButton);
    QWidget::setTabOrder(addTeacherPushButton, removeTeacherPushButton);
    QWidget::setTabOrder(removeTeacherPushButton, renameTeacherPushButton);
    QWidget::setTabOrder(renameTeacherPushButton, sortTeachersPushButton);
    QWidget::setTabOrder(sortTeachersPushButton, activateTeacherPushButton);
    QWidget::setTabOrder(activateTeacherPushButton, deactivateTeacherPushButton);
    QWidget::setTabOrder(deactivateTeacherPushButton, closePushButton);
    QWidget::setTabOrder(closePushButton, currentTeacherTextEdit);

    retranslateUi(TeachersForm_template);
    QObject::connect(renameTeacherPushButton, SIGNAL(clicked()), TeachersForm_template, SLOT(renameTeacher()));
    QObject::connect(closePushButton, SIGNAL(clicked()), TeachersForm_template, SLOT(close()));
    QObject::connect(addTeacherPushButton, SIGNAL(clicked()), TeachersForm_template, SLOT(addTeacher()));
    QObject::connect(sortTeachersPushButton, SIGNAL(clicked()), TeachersForm_template, SLOT(sortTeachers()));
    QObject::connect(removeTeacherPushButton, SIGNAL(clicked()), TeachersForm_template, SLOT(removeTeacher()));
    QObject::connect(teachersListBox, SIGNAL(highlighted(int)), TeachersForm_template, SLOT(teacherChanged(int)));
    QObject::connect(activateTeacherPushButton, SIGNAL(clicked()), TeachersForm_template, SLOT(activateTeacher()));
    QObject::connect(deactivateTeacherPushButton, SIGNAL(clicked()), TeachersForm_template, SLOT(deactivateTeacher()));
    QObject::connect(teachersListBox, SIGNAL(selected(QString)), TeachersForm_template, SLOT(renameTeacher()));

    QMetaObject::connectSlotsByName(TeachersForm_template);
    } // setupUi

    void retranslateUi(QDialog *TeachersForm_template)
    {
    TeachersForm_template->setWindowTitle(QApplication::translate("TeachersForm_template", "Teachers", 0, QApplication::UnicodeUTF8));
    addTeacherPushButton->setText(QApplication::translate("TeachersForm_template", "Add teacher", 0, QApplication::UnicodeUTF8));
    removeTeacherPushButton->setText(QApplication::translate("TeachersForm_template", "Remove current", 0, QApplication::UnicodeUTF8));
    sortTeachersPushButton->setText(QApplication::translate("TeachersForm_template", "Sort alphabetically", 0, QApplication::UnicodeUTF8));
    teachersListBox->clear();
    teachersListBox->insertItem(QApplication::translate("TeachersForm_template", "New Item", 0, QApplication::UnicodeUTF8));
    closePushButton->setText(QApplication::translate("TeachersForm_template", "Close", 0, QApplication::UnicodeUTF8));
    renameTeacherPushButton->setText(QApplication::translate("TeachersForm_template", "Rename current", 0, QApplication::UnicodeUTF8));
    activateTeacherPushButton->setText(QApplication::translate("TeachersForm_template", "Activate all activities for selected teacher", 0, QApplication::UnicodeUTF8));
    deactivateTeacherPushButton->setText(QApplication::translate("TeachersForm_template", "De-activate all activities for selected teacher", 0, QApplication::UnicodeUTF8));
    Q_UNUSED(TeachersForm_template);
    } // retranslateUi

};

namespace Ui {
    class TeachersForm_template: public Ui_TeachersForm_template {};
} // namespace Ui

QT_END_NAMESPACE

class TeachersForm_template : public QDialog, public Ui::TeachersForm_template
{
    Q_OBJECT

public:
    TeachersForm_template(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~TeachersForm_template();

public slots:
    virtual void addTeacher();
    virtual void removeTeacher();
    virtual void renameTeacher();
    virtual void sortTeachers();
    virtual void teacherChanged(int);
    virtual void activateTeacher();
    virtual void deactivateTeacher();

protected slots:
    virtual void languageChange();

};

#endif // TEACHERSFORM_TEMPLATE_H
