#ifndef TIMETABLEVIEWROOMSFORM_TEMPLATE_H
#define TIMETABLEVIEWROOMSFORM_TEMPLATE_H

#include <qvariant.h>


#include <Qt3Support/Q3Header>
#include <Qt3Support/Q3ListBox>
#include <Qt3Support/Q3MimeSourceFactory>
#include <Qt3Support/Q3Table>
#include <Qt3Support/Q3TextEdit>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>

QT_BEGIN_NAMESPACE

class Ui_TimetableViewRoomsForm_template
{
public:
    QGridLayout *gridLayout;
    QLabel *roomsTextLabel;
    QLabel *roomNameTextLabel;
    Q3Table *roomsTimetableTable;
    Q3ListBox *roomsListBox;
    QLabel *detailsTextLabel;
    Q3TextEdit *detailsTextEdit;
    QPushButton *lockPushButton;
    QPushButton *closePushButton;
    QPushButton *lockSpacePushButton;
    QPushButton *lockTimePushButton;

    void setupUi(QDialog *TimetableViewRoomsForm_template)
    {
    if (TimetableViewRoomsForm_template->objectName().isEmpty())
        TimetableViewRoomsForm_template->setObjectName(QString::fromUtf8("TimetableViewRoomsForm_template"));
    TimetableViewRoomsForm_template->resize(757, 530);
    gridLayout = new QGridLayout(TimetableViewRoomsForm_template);
    gridLayout->setSpacing(6);
    gridLayout->setMargin(11);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    roomsTextLabel = new QLabel(TimetableViewRoomsForm_template);
    roomsTextLabel->setObjectName(QString::fromUtf8("roomsTextLabel"));
    roomsTextLabel->setWordWrap(false);

    gridLayout->addWidget(roomsTextLabel, 0, 0, 1, 2);

    roomNameTextLabel = new QLabel(TimetableViewRoomsForm_template);
    roomNameTextLabel->setObjectName(QString::fromUtf8("roomNameTextLabel"));
    roomNameTextLabel->setWordWrap(false);

    gridLayout->addWidget(roomNameTextLabel, 3, 0, 1, 2);

    roomsTimetableTable = new Q3Table(TimetableViewRoomsForm_template);
    roomsTimetableTable->setObjectName(QString::fromUtf8("roomsTimetableTable"));
    roomsTimetableTable->setNumRows(12);
    roomsTimetableTable->setNumCols(5);
    roomsTimetableTable->setReadOnly(true);

    gridLayout->addWidget(roomsTimetableTable, 4, 0, 1, 2);

    roomsListBox = new Q3ListBox(TimetableViewRoomsForm_template);
    roomsListBox->setObjectName(QString::fromUtf8("roomsListBox"));

    gridLayout->addWidget(roomsListBox, 1, 0, 2, 1);

    detailsTextLabel = new QLabel(TimetableViewRoomsForm_template);
    detailsTextLabel->setObjectName(QString::fromUtf8("detailsTextLabel"));
    detailsTextLabel->setWordWrap(false);

    gridLayout->addWidget(detailsTextLabel, 1, 1, 1, 1);

    detailsTextEdit = new Q3TextEdit(TimetableViewRoomsForm_template);
    detailsTextEdit->setObjectName(QString::fromUtf8("detailsTextEdit"));
    detailsTextEdit->setReadOnly(true);

    gridLayout->addWidget(detailsTextEdit, 2, 1, 1, 1);

    lockPushButton = new QPushButton(TimetableViewRoomsForm_template);
    lockPushButton->setObjectName(QString::fromUtf8("lockPushButton"));

    gridLayout->addWidget(lockPushButton, 6, 0, 1, 1);

    closePushButton = new QPushButton(TimetableViewRoomsForm_template);
    closePushButton->setObjectName(QString::fromUtf8("closePushButton"));

    gridLayout->addWidget(closePushButton, 6, 1, 1, 1);

    lockSpacePushButton = new QPushButton(TimetableViewRoomsForm_template);
    lockSpacePushButton->setObjectName(QString::fromUtf8("lockSpacePushButton"));

    gridLayout->addWidget(lockSpacePushButton, 5, 1, 1, 1);

    lockTimePushButton = new QPushButton(TimetableViewRoomsForm_template);
    lockTimePushButton->setObjectName(QString::fromUtf8("lockTimePushButton"));

    gridLayout->addWidget(lockTimePushButton, 5, 0, 1, 1);

    QWidget::setTabOrder(roomsListBox, detailsTextEdit);
    QWidget::setTabOrder(detailsTextEdit, roomsTimetableTable);
    QWidget::setTabOrder(roomsTimetableTable, lockTimePushButton);
    QWidget::setTabOrder(lockTimePushButton, lockSpacePushButton);
    QWidget::setTabOrder(lockSpacePushButton, lockPushButton);
    QWidget::setTabOrder(lockPushButton, closePushButton);

    retranslateUi(TimetableViewRoomsForm_template);
    QObject::connect(closePushButton, SIGNAL(clicked()), TimetableViewRoomsForm_template, SLOT(close()));
    QObject::connect(roomsListBox, SIGNAL(highlighted(QString)), TimetableViewRoomsForm_template, SLOT(roomChanged(QString)));
    QObject::connect(roomsTimetableTable, SIGNAL(currentChanged(int,int)), TimetableViewRoomsForm_template, SLOT(detailActivity(int,int)));
    QObject::connect(lockPushButton, SIGNAL(clicked()), TimetableViewRoomsForm_template, SLOT(lock()));
    QObject::connect(lockTimePushButton, SIGNAL(clicked()), TimetableViewRoomsForm_template, SLOT(lockTime()));
    QObject::connect(lockSpacePushButton, SIGNAL(clicked()), TimetableViewRoomsForm_template, SLOT(lockSpace()));

    QMetaObject::connectSlotsByName(TimetableViewRoomsForm_template);
    } // setupUi

    void retranslateUi(QDialog *TimetableViewRoomsForm_template)
    {
    TimetableViewRoomsForm_template->setWindowTitle(QApplication::translate("TimetableViewRoomsForm_template", "Viewing the timetable for the rooms", 0, QApplication::UnicodeUTF8));
    roomsTextLabel->setText(QApplication::translate("TimetableViewRoomsForm_template", "Room", 0, QApplication::UnicodeUTF8));
    roomNameTextLabel->setText(QApplication::translate("TimetableViewRoomsForm_template", "Room's name", 0, QApplication::UnicodeUTF8));
    roomsListBox->clear();
    roomsListBox->insertItem(QApplication::translate("TimetableViewRoomsForm_template", "New Item", 0, QApplication::UnicodeUTF8));
    detailsTextLabel->setText(QApplication::translate("TimetableViewRoomsForm_template", "Details", 0, QApplication::UnicodeUTF8));
    detailsTextEdit->setText(QApplication::translate("TimetableViewRoomsForm_template", "Please click on the table for details for a specific activity.", 0, QApplication::UnicodeUTF8));
    lockPushButton->setText(QApplication::translate("TimetableViewRoomsForm_template", "Lock selected activities", 0, QApplication::UnicodeUTF8));
    closePushButton->setText(QApplication::translate("TimetableViewRoomsForm_template", "Close", 0, QApplication::UnicodeUTF8));
    lockSpacePushButton->setText(QApplication::translate("TimetableViewRoomsForm_template", "Lock selected activities (space)", 0, QApplication::UnicodeUTF8));
    lockTimePushButton->setText(QApplication::translate("TimetableViewRoomsForm_template", "Lock selected activities (time)", 0, QApplication::UnicodeUTF8));
    Q_UNUSED(TimetableViewRoomsForm_template);
    } // retranslateUi

};

namespace Ui {
    class TimetableViewRoomsForm_template: public Ui_TimetableViewRoomsForm_template {};
} // namespace Ui

QT_END_NAMESPACE

class TimetableViewRoomsForm_template : public QDialog, public Ui::TimetableViewRoomsForm_template
{
    Q_OBJECT

public:
    TimetableViewRoomsForm_template(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~TimetableViewRoomsForm_template();

public slots:
    virtual void detailActivity(int, int);
    virtual void roomChanged(const QString&);
    virtual void lock();
    virtual void lockTime();
    virtual void lockSpace();

protected slots:
    virtual void languageChange();

};

#endif // TIMETABLEVIEWROOMSFORM_TEMPLATE_H
