#ifndef TIMETABLEVIEWTEACHERSFORM_TEMPLATE_H
#define TIMETABLEVIEWTEACHERSFORM_TEMPLATE_H

#include <qvariant.h>


#include <Qt3Support/Q3Header>
#include <Qt3Support/Q3ListBox>
#include <Qt3Support/Q3MimeSourceFactory>
#include <Qt3Support/Q3Table>
#include <Qt3Support/Q3TextEdit>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>

QT_BEGIN_NAMESPACE

class Ui_TimetableViewTeachersForm_template
{
public:
    QGridLayout *gridLayout;
    QPushButton *closePushButton;
    QLabel *detailsTextLabel;
    Q3Table *teachersTimetableTable;
    QLabel *teacherNameTextLabel;
    Q3TextEdit *detailsTextEdit;
    QLabel *teachersTextLabel;
    Q3ListBox *teachersListBox;
    QPushButton *lockSpacePushButton;
    QPushButton *lockTimePushButton;
    QPushButton *lockTimeSpacePushButton;

    void setupUi(QDialog *TimetableViewTeachersForm_template)
    {
    if (TimetableViewTeachersForm_template->objectName().isEmpty())
        TimetableViewTeachersForm_template->setObjectName(QString::fromUtf8("TimetableViewTeachersForm_template"));
    TimetableViewTeachersForm_template->resize(757, 518);
    gridLayout = new QGridLayout(TimetableViewTeachersForm_template);
    gridLayout->setSpacing(6);
    gridLayout->setMargin(11);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    closePushButton = new QPushButton(TimetableViewTeachersForm_template);
    closePushButton->setObjectName(QString::fromUtf8("closePushButton"));

    gridLayout->addWidget(closePushButton, 4, 2, 1, 1);

    detailsTextLabel = new QLabel(TimetableViewTeachersForm_template);
    detailsTextLabel->setObjectName(QString::fromUtf8("detailsTextLabel"));
    detailsTextLabel->setWordWrap(false);

    gridLayout->addWidget(detailsTextLabel, 0, 1, 1, 1);

    teachersTimetableTable = new Q3Table(TimetableViewTeachersForm_template);
    teachersTimetableTable->setObjectName(QString::fromUtf8("teachersTimetableTable"));
    teachersTimetableTable->setNumRows(12);
    teachersTimetableTable->setNumCols(5);
    teachersTimetableTable->setReadOnly(true);

    gridLayout->addWidget(teachersTimetableTable, 6, 0, 1, 3);

    teacherNameTextLabel = new QLabel(TimetableViewTeachersForm_template);
    teacherNameTextLabel->setObjectName(QString::fromUtf8("teacherNameTextLabel"));
    teacherNameTextLabel->setWordWrap(false);

    gridLayout->addWidget(teacherNameTextLabel, 5, 0, 1, 3);

    detailsTextEdit = new Q3TextEdit(TimetableViewTeachersForm_template);
    detailsTextEdit->setObjectName(QString::fromUtf8("detailsTextEdit"));
    detailsTextEdit->setReadOnly(true);

    gridLayout->addWidget(detailsTextEdit, 1, 1, 4, 1);

    teachersTextLabel = new QLabel(TimetableViewTeachersForm_template);
    teachersTextLabel->setObjectName(QString::fromUtf8("teachersTextLabel"));
    teachersTextLabel->setWordWrap(false);

    gridLayout->addWidget(teachersTextLabel, 0, 0, 1, 1);

    teachersListBox = new Q3ListBox(TimetableViewTeachersForm_template);
    teachersListBox->setObjectName(QString::fromUtf8("teachersListBox"));

    gridLayout->addWidget(teachersListBox, 1, 0, 4, 1);

    lockSpacePushButton = new QPushButton(TimetableViewTeachersForm_template);
    lockSpacePushButton->setObjectName(QString::fromUtf8("lockSpacePushButton"));

    gridLayout->addWidget(lockSpacePushButton, 2, 2, 1, 1);

    lockTimePushButton = new QPushButton(TimetableViewTeachersForm_template);
    lockTimePushButton->setObjectName(QString::fromUtf8("lockTimePushButton"));

    gridLayout->addWidget(lockTimePushButton, 0, 2, 2, 1);

    lockTimeSpacePushButton = new QPushButton(TimetableViewTeachersForm_template);
    lockTimeSpacePushButton->setObjectName(QString::fromUtf8("lockTimeSpacePushButton"));

    gridLayout->addWidget(lockTimeSpacePushButton, 3, 2, 1, 1);

    QWidget::setTabOrder(teachersListBox, teachersTimetableTable);
    QWidget::setTabOrder(teachersTimetableTable, lockTimePushButton);
    QWidget::setTabOrder(lockTimePushButton, closePushButton);
    QWidget::setTabOrder(closePushButton, detailsTextEdit);

    retranslateUi(TimetableViewTeachersForm_template);
    QObject::connect(closePushButton, SIGNAL(clicked()), TimetableViewTeachersForm_template, SLOT(close()));
    QObject::connect(teachersListBox, SIGNAL(highlighted(QString)), TimetableViewTeachersForm_template, SLOT(teacherChanged(QString)));
    QObject::connect(teachersTimetableTable, SIGNAL(currentChanged(int,int)), TimetableViewTeachersForm_template, SLOT(detailActivity(int,int)));
    QObject::connect(lockTimePushButton, SIGNAL(clicked()), TimetableViewTeachersForm_template, SLOT(lockTime()));
    QObject::connect(lockSpacePushButton, SIGNAL(clicked()), TimetableViewTeachersForm_template, SLOT(lockSpace()));
    QObject::connect(lockTimeSpacePushButton, SIGNAL(clicked()), TimetableViewTeachersForm_template, SLOT(lockTimeSpace()));

    QMetaObject::connectSlotsByName(TimetableViewTeachersForm_template);
    } // setupUi

    void retranslateUi(QDialog *TimetableViewTeachersForm_template)
    {
    TimetableViewTeachersForm_template->setWindowTitle(QApplication::translate("TimetableViewTeachersForm_template", "Viewing the timetable for the teachers", 0, QApplication::UnicodeUTF8));
    closePushButton->setText(QApplication::translate("TimetableViewTeachersForm_template", "Close", 0, QApplication::UnicodeUTF8));
    detailsTextLabel->setText(QApplication::translate("TimetableViewTeachersForm_template", "Details", 0, QApplication::UnicodeUTF8));
    teacherNameTextLabel->setText(QApplication::translate("TimetableViewTeachersForm_template", "Teacher's name", 0, QApplication::UnicodeUTF8));
    detailsTextEdit->setText(QApplication::translate("TimetableViewTeachersForm_template", "Please click on the table for details for a specific activity.", 0, QApplication::UnicodeUTF8));
    teachersTextLabel->setText(QApplication::translate("TimetableViewTeachersForm_template", "Teacher", 0, QApplication::UnicodeUTF8));
    teachersListBox->clear();
    teachersListBox->insertItem(QApplication::translate("TimetableViewTeachersForm_template", "New Item", 0, QApplication::UnicodeUTF8));
    lockSpacePushButton->setText(QApplication::translate("TimetableViewTeachersForm_template", "Lock selected activities\n"
"(only space)", 0, QApplication::UnicodeUTF8));
    lockTimePushButton->setText(QApplication::translate("TimetableViewTeachersForm_template", "Lock selected activities\n"
"(only time)", 0, QApplication::UnicodeUTF8));
    lockTimeSpacePushButton->setText(QApplication::translate("TimetableViewTeachersForm_template", "Lock selected activities\n"
"(time&&space)", 0, QApplication::UnicodeUTF8));
    lockTimeSpacePushButton->setShortcut(QString());
    Q_UNUSED(TimetableViewTeachersForm_template);
    } // retranslateUi

};

namespace Ui {
    class TimetableViewTeachersForm_template: public Ui_TimetableViewTeachersForm_template {};
} // namespace Ui

QT_END_NAMESPACE

class TimetableViewTeachersForm_template : public QDialog, public Ui::TimetableViewTeachersForm_template
{
    Q_OBJECT

public:
    TimetableViewTeachersForm_template(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~TimetableViewTeachersForm_template();

public slots:
    virtual void detailActivity(int, int);
    virtual void teacherChanged(const QString&);
    virtual void lockTime();
    virtual void lockSpace();
    virtual void lockTimeSpace();

protected slots:
    virtual void languageChange();

};

#endif // TIMETABLEVIEWTEACHERSFORM_TEMPLATE_H
