#ifndef YEARSFORM_TEMPLATE_H
#define YEARSFORM_TEMPLATE_H

#include <qvariant.h>


#include <Qt3Support/Q3ListBox>
#include <Qt3Support/Q3MimeSourceFactory>
#include <Qt3Support/Q3TextEdit>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QPushButton>

QT_BEGIN_NAMESPACE

class Ui_YearsForm_template
{
public:
    QGridLayout *gridLayout;
    Q3ListBox *yearsListBox;
    QPushButton *closePushButton;
    QPushButton *deactivateStudentsPushButton;
    Q3TextEdit *detailsTextEdit;
    QPushButton *addYearPushButton;
    QPushButton *removeYearPushButton;
    QPushButton *modifyYearPushButton;
    QPushButton *sortYearsPushButton;
    QPushButton *divisionsPushButton;
    QPushButton *activateStudentsPushButton;

    void setupUi(QDialog *YearsForm_template)
    {
    if (YearsForm_template->objectName().isEmpty())
        YearsForm_template->setObjectName(QString::fromUtf8("YearsForm_template"));
    YearsForm_template->resize(517, 566);
    gridLayout = new QGridLayout(YearsForm_template);
    gridLayout->setSpacing(6);
    gridLayout->setMargin(11);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    yearsListBox = new Q3ListBox(YearsForm_template);
    yearsListBox->setObjectName(QString::fromUtf8("yearsListBox"));

    gridLayout->addWidget(yearsListBox, 0, 0, 1, 1);

    closePushButton = new QPushButton(YearsForm_template);
    closePushButton->setObjectName(QString::fromUtf8("closePushButton"));

    gridLayout->addWidget(closePushButton, 6, 0, 1, 2);

    deactivateStudentsPushButton = new QPushButton(YearsForm_template);
    deactivateStudentsPushButton->setObjectName(QString::fromUtf8("deactivateStudentsPushButton"));

    gridLayout->addWidget(deactivateStudentsPushButton, 5, 0, 1, 2);

    detailsTextEdit = new Q3TextEdit(YearsForm_template);
    detailsTextEdit->setObjectName(QString::fromUtf8("detailsTextEdit"));
    detailsTextEdit->setReadOnly(true);

    gridLayout->addWidget(detailsTextEdit, 0, 1, 1, 1);

    addYearPushButton = new QPushButton(YearsForm_template);
    addYearPushButton->setObjectName(QString::fromUtf8("addYearPushButton"));

    gridLayout->addWidget(addYearPushButton, 1, 0, 1, 1);

    removeYearPushButton = new QPushButton(YearsForm_template);
    removeYearPushButton->setObjectName(QString::fromUtf8("removeYearPushButton"));

    gridLayout->addWidget(removeYearPushButton, 1, 1, 1, 1);

    modifyYearPushButton = new QPushButton(YearsForm_template);
    modifyYearPushButton->setObjectName(QString::fromUtf8("modifyYearPushButton"));

    gridLayout->addWidget(modifyYearPushButton, 2, 0, 1, 1);

    sortYearsPushButton = new QPushButton(YearsForm_template);
    sortYearsPushButton->setObjectName(QString::fromUtf8("sortYearsPushButton"));

    gridLayout->addWidget(sortYearsPushButton, 2, 1, 1, 1);

    divisionsPushButton = new QPushButton(YearsForm_template);
    divisionsPushButton->setObjectName(QString::fromUtf8("divisionsPushButton"));

    gridLayout->addWidget(divisionsPushButton, 3, 0, 1, 2);

    activateStudentsPushButton = new QPushButton(YearsForm_template);
    activateStudentsPushButton->setObjectName(QString::fromUtf8("activateStudentsPushButton"));

    gridLayout->addWidget(activateStudentsPushButton, 4, 0, 1, 2);

    QWidget::setTabOrder(yearsListBox, detailsTextEdit);
    QWidget::setTabOrder(detailsTextEdit, addYearPushButton);
    QWidget::setTabOrder(addYearPushButton, removeYearPushButton);
    QWidget::setTabOrder(removeYearPushButton, modifyYearPushButton);
    QWidget::setTabOrder(modifyYearPushButton, sortYearsPushButton);
    QWidget::setTabOrder(sortYearsPushButton, divisionsPushButton);
    QWidget::setTabOrder(divisionsPushButton, activateStudentsPushButton);
    QWidget::setTabOrder(activateStudentsPushButton, deactivateStudentsPushButton);
    QWidget::setTabOrder(deactivateStudentsPushButton, closePushButton);

    retranslateUi(YearsForm_template);
    QObject::connect(addYearPushButton, SIGNAL(clicked()), YearsForm_template, SLOT(addYear()));
    QObject::connect(closePushButton, SIGNAL(clicked()), YearsForm_template, SLOT(close()));
    QObject::connect(removeYearPushButton, SIGNAL(clicked()), YearsForm_template, SLOT(removeYear()));
    QObject::connect(yearsListBox, SIGNAL(highlighted(int)), YearsForm_template, SLOT(yearChanged()));
    QObject::connect(modifyYearPushButton, SIGNAL(clicked()), YearsForm_template, SLOT(modifyYear()));
    QObject::connect(sortYearsPushButton, SIGNAL(clicked()), YearsForm_template, SLOT(sortYears()));
    QObject::connect(activateStudentsPushButton, SIGNAL(clicked()), YearsForm_template, SLOT(activateStudents()));
    QObject::connect(deactivateStudentsPushButton, SIGNAL(clicked()), YearsForm_template, SLOT(deactivateStudents()));
    QObject::connect(divisionsPushButton, SIGNAL(clicked()), YearsForm_template, SLOT(divideYear()));
    QObject::connect(yearsListBox, SIGNAL(selected(QString)), YearsForm_template, SLOT(modifyYear()));

    QMetaObject::connectSlotsByName(YearsForm_template);
    } // setupUi

    void retranslateUi(QDialog *YearsForm_template)
    {
    YearsForm_template->setWindowTitle(QApplication::translate("YearsForm_template", "Years (forms, classes) of students", 0, QApplication::UnicodeUTF8));
    yearsListBox->clear();
    yearsListBox->insertItem(QApplication::translate("YearsForm_template", "New Item", 0, QApplication::UnicodeUTF8));
    closePushButton->setText(QApplication::translate("YearsForm_template", "Close", 0, QApplication::UnicodeUTF8));
    deactivateStudentsPushButton->setText(QApplication::translate("YearsForm_template", "De-activate all activities for selected students year", 0, QApplication::UnicodeUTF8));
    addYearPushButton->setText(QApplication::translate("YearsForm_template", "Add year (form, class)", 0, QApplication::UnicodeUTF8));
    removeYearPushButton->setText(QApplication::translate("YearsForm_template", "Remove current", 0, QApplication::UnicodeUTF8));
    modifyYearPushButton->setText(QApplication::translate("YearsForm_template", "Modify current", 0, QApplication::UnicodeUTF8));
    sortYearsPushButton->setText(QApplication::translate("YearsForm_template", "Sort alphabetically", 0, QApplication::UnicodeUTF8));
    divisionsPushButton->setText(QApplication::translate("YearsForm_template", "Divide year automatically by selecting categories", 0, QApplication::UnicodeUTF8));
    activateStudentsPushButton->setText(QApplication::translate("YearsForm_template", "Activate all activities for selected students year", 0, QApplication::UnicodeUTF8));
    Q_UNUSED(YearsForm_template);
    } // retranslateUi

};

namespace Ui {
    class YearsForm_template: public Ui_YearsForm_template {};
} // namespace Ui

QT_END_NAMESPACE

class YearsForm_template : public QDialog, public Ui::YearsForm_template
{
    Q_OBJECT

public:
    YearsForm_template(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~YearsForm_template();

public slots:
    virtual void addYear();
    virtual void removeYear();
    virtual void yearChanged();
    virtual void modifyYear();
    virtual void sortYears();
    virtual void activateStudents();
    virtual void deactivateStudents();
    virtual void divideYear();

protected slots:
    virtual void languageChange();

};

#endif // YEARSFORM_TEMPLATE_H
